#ifndef _DECL_taskGraph_H_
#define _DECL_taskGraph_H_
#include "charm++.h"
/* DECLS: message callbackMsg;
 */
class callbackMsg;
class CMessage_callbackMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t,void*p) { return p; }
    void* operator new(size_t,const int);
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p,void*){CkFreeMsg(p);}
    void operator delete(void*p,const int){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p,int*,const int){CkFreeMsg(p);}
    void operator delete(void*p,int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p,size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t,int*,int);
    CMessage_callbackMsg() {};
    static void *pack(callbackMsg *p);
    static callbackMsg* unpack(void* p);
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: array taskGraphArray: ArrayElement{
taskGraphArray(CkMigrateMessage* impl_msg);
taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
void requestData(const CkArrayIndexMax &from);
void depositData(const CkPointer<taskGraphSolver> &data);
void deleteElement(void);
};
 */
 class taskGraphArray;
 class CkIndex_taskGraphArray;
 class CProxy_taskGraphArray;
 class CProxyElement_taskGraphArray;
 class CProxySection_taskGraphArray;
/* --------------- index object ------------------ */
class CkIndex_taskGraphArray{
  public:
    typedef taskGraphArray local_t;
    typedef CkIndex_taskGraphArray index_t;
    typedef CProxy_taskGraphArray proxy_t;
    typedef CProxyElement_taskGraphArray element_t;
    typedef CProxySection_taskGraphArray section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: taskGraphArray(CkMigrateMessage* impl_msg);
 */
    static int __idx_taskGraphArray_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_taskGraphArray_CkMigrateMessage; }
    static void _call_taskGraphArray_CkMigrateMessage(void* impl_msg,taskGraphArray* impl_obj);

/* DECLS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */
    static int __idx_taskGraphArray_marshall1;
    static int ckNew(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults) { return __idx_taskGraphArray_marshall1; }
    static void _call_taskGraphArray_marshall1(void* impl_msg,taskGraphArray* impl_obj);
    static int _callmarshall_taskGraphArray_marshall1(char* impl_buf,taskGraphArray* impl_obj);
    static void _marshallmessagepup_taskGraphArray_marshall1(PUP::er &p,void *msg);

/* DECLS: void requestData(const CkArrayIndexMax &from);
 */
    static int __idx_requestData_marshall2;
    static int requestData(const CkArrayIndexMax &from) { return __idx_requestData_marshall2; }
    static void _call_requestData_marshall2(void* impl_msg,taskGraphArray* impl_obj);
    static int _callmarshall_requestData_marshall2(char* impl_buf,taskGraphArray* impl_obj);
    static void _marshallmessagepup_requestData_marshall2(PUP::er &p,void *msg);

/* DECLS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
    static int __idx_depositData_marshall3;
    static int depositData(const CkPointer<taskGraphSolver> &data) { return __idx_depositData_marshall3; }
    static void _call_depositData_marshall3(void* impl_msg,taskGraphArray* impl_obj);
    static int _callmarshall_depositData_marshall3(char* impl_buf,taskGraphArray* impl_obj);
    static void _marshallmessagepup_depositData_marshall3(PUP::er &p,void *msg);

/* DECLS: void deleteElement(void);
 */
    static int __idx_deleteElement_void;
    static int deleteElement(void) { return __idx_deleteElement_void; }
    static void _call_deleteElement_void(void* impl_msg,taskGraphArray* impl_obj);
};
/* --------------- element proxy ------------------ */
 class CProxyElement_taskGraphArray : public CProxyElement_ArrayElement{
  public:
    typedef taskGraphArray local_t;
    typedef CkIndex_taskGraphArray index_t;
    typedef CProxy_taskGraphArray proxy_t;
    typedef CProxyElement_taskGraphArray element_t;
    typedef CProxySection_taskGraphArray section_t;

    CProxyElement_taskGraphArray(void) {}
    CProxyElement_taskGraphArray(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *to) {
      CProxyElement_ArrayElement::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_ELEMENT(CProxyElement_ArrayElement)
    taskGraphArray *ckLocal(void) const
      { return (taskGraphArray *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_taskGraphArray(const CkArrayID &aid,const CkArrayIndexMax &idx,CkGroupID dTo)
        :CProxyElement_ArrayElement(aid,idx,dTo) {}
    CProxyElement_taskGraphArray(const CkArrayID &aid,const CkArrayIndexMax &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: taskGraphArray(CkMigrateMessage* impl_msg);
 */

/* DECLS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */
    void insert(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults, int onPE=-1, const CkEntryOptions *impl_e_opts=NULL);
/* DECLS: void requestData(const CkArrayIndexMax &from);
 */
    void requestData(const CkArrayIndexMax &from, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
    void depositData(const CkPointer<taskGraphSolver> &data, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void deleteElement(void);
 */
    void deleteElement(void) ;
};
PUPmarshall(CProxyElement_taskGraphArray);
/* ---------------- collective proxy -------------- */
 class CProxy_taskGraphArray : public CProxy_ArrayElement{
  public:
    typedef taskGraphArray local_t;
    typedef CkIndex_taskGraphArray index_t;
    typedef CProxy_taskGraphArray proxy_t;
    typedef CProxyElement_taskGraphArray element_t;
    typedef CProxySection_taskGraphArray section_t;

    CProxy_taskGraphArray(void) {}
    CProxy_taskGraphArray(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *to) {
      CProxy_ArrayElement::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY(CProxy_ArrayElement)
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_taskGraphArray operator [] (const CkArrayIndexMax &idx) const
        {return CProxyElement_taskGraphArray(ckGetArrayID(), idx, ckDelegatedIdx());}
    CProxyElement_taskGraphArray operator() (const CkArrayIndexMax &idx) const
        {return CProxyElement_taskGraphArray(ckGetArrayID(), idx, ckDelegatedIdx());}
    CProxy_taskGraphArray(const CkArrayID &aid,CkGroupID dTo) 
        :CProxy_ArrayElement(aid,dTo) {}
    CProxy_taskGraphArray(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: taskGraphArray(CkMigrateMessage* impl_msg);
 */

/* DECLS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */
    static CkArrayID ckNew(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults, const CkArrayOptions &opts, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void requestData(const CkArrayIndexMax &from);
 */
    void requestData(const CkArrayIndexMax &from, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
    void depositData(const CkPointer<taskGraphSolver> &data, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void deleteElement(void);
 */
    void deleteElement(void) ;
};
PUPmarshall(CProxy_taskGraphArray);
/* ---------------- section proxy -------------- */
 class CProxySection_taskGraphArray : public CProxySection_ArrayElement{
  public:
    typedef taskGraphArray local_t;
    typedef CkIndex_taskGraphArray index_t;
    typedef CProxy_taskGraphArray proxy_t;
    typedef CProxyElement_taskGraphArray element_t;
    typedef CProxySection_taskGraphArray section_t;

    CProxySection_taskGraphArray(void) {}
    void ckDelegate(CkDelegateMgr *to) {
      CProxySection_ArrayElement::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_SECTION(CProxySection_ArrayElement)
//Generalized array indexing:
    CProxyElement_taskGraphArray operator [] (const CkArrayIndexMax &idx) const
        {return CProxyElement_taskGraphArray(ckGetArrayID(), idx, ckDelegatedIdx());}
    CProxyElement_taskGraphArray operator() (const CkArrayIndexMax &idx) const
        {return CProxyElement_taskGraphArray(ckGetArrayID(), idx, ckDelegatedIdx());}
    CProxySection_taskGraphArray(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CkGroupID dTo) 
        :CProxySection_ArrayElement(aid,elems,nElems,dTo) {}
    CProxySection_taskGraphArray(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_taskGraphArray(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: taskGraphArray(CkMigrateMessage* impl_msg);
 */

/* DECLS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */

/* DECLS: void requestData(const CkArrayIndexMax &from);
 */
    void requestData(const CkArrayIndexMax &from, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
    void depositData(const CkPointer<taskGraphSolver> &data, const CkEntryOptions *impl_e_opts=NULL) ;

/* DECLS: void deleteElement(void);
 */
    void deleteElement(void) ;
};
PUPmarshall(CProxySection_taskGraphArray);
typedef CBaseT<ArrayElementT<CkIndexMax>,CProxy_taskGraphArray>  CBase_taskGraphArray;

extern void _registertaskGraph(void);
#endif
